#!/bin/sh

case $1 in
	--sdk-mod-ver)
	#Print SDK support version
	echo "1.0";
	;;
	--name)
	#Print package name
	echo "Lan port power reset script"
	;;
	--pkg-ver)
	#Print package version
	echo "1.0";
	;;
	--vendor)
	#Print package vendor
	echo "Synology";
	;;
	--pre)
	;;
	--post)
		(
		if flock -n -x 8; then
			# Skip power reset on enable/disable secondary wan
			old_wan1_enable=$(jq '.old.networks | has("wan1")' "${ARGS_FILE_PATH}")
			new_wan1_enable=$(jq '.new.networks | has("wan1")' "${ARGS_FILE_PATH}")
			if [ "${old_wan1_enable}" != "${new_wan1_enable}" ]; then
				return
			fi

			lans="$(jq -r '.new.networks | keys | .[]' "${ARGS_FILE_PATH}")"
			for lan in $lans; do
				is_affected=$(jq -r ".new.networks.${lan}.is_affected" "${ARGS_FILE_PATH}")
				if [ "${is_affected}" = "true" ]; then
					affect_lans="${lan},${affect_lans}"
				fi
			done
			synolanportpower --reset-by-interface "${affect_lans}"
		fi
		)8> /var/lock/lan_port_power_reset.lock
	;;
	*)
	echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
	;;
esac

