#!/bin/sh

case $1 in
	--sdk-mod-ver)
		# Print SDK support version
		echo "1.0";
		;;
	--name)
		# Print package name
		echo "synofirewall"
		;;
	--pkg-ver)
		# Print package version
		echo "1.0";
		;;
	--vendor)
		# Print package vendor
		echo "Synology";
		;;
	--pre)
		# Not supported by the object framework
		;;
	--post)
		old_context=$(jq -r '.old.context' "${ARGS_FILE_PATH}")
		new_context=$(jq -r '.new.context' "${ARGS_FILE_PATH}")
		if [ "${old_context}" == "${new_context}" ]; then
			return
		fi

		/sbin/iptables -t mangle -F NTP_WORKAROUND_OUTPUT
		/sbin/iptables -t nat -F NTP_WORKAROUND_POSTROUTING
		if [ "router" == "${new_context}" ]; then
			/sbin/iptables -t nat -I NTP_WORKAROUND_POSTROUTING -p udp --sport 123 -j MASQUERADE --to-ports 32768-60000
		else # for bridge/wds mode.
			/sbin/iptables -t nat -I NTP_WORKAROUND_POSTROUTING -p udp --sport 123 -m mark ! --mark 0x10000000/0x10000000 -j MASQUERADE --to-ports 32768-60000
			/sbin/iptables -t mangle -I NTP_WORKAROUND_OUTPUT -p udp -m udp ! --sport 123 -j MARK --set-xmark 0x10000000/0x10000000
		fi
		;;
	*)
		echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
		;;
esac

